<?php declare(strict_types=1);

namespace ConvoPlugin\Convo\Wp;


use Convo\Core\IAdminUser;
use WP_User;

class AdminUser implements IAdminUser {

	private $_id;
	private $_username;
	private $_name;
	private $_email;
	private $_password;

	public function __construct(WP_User $user)
	{
		$this->_id			=	$user->ID;
		$this->_username	=	$user->user_login;
		$this->_name		=	$user->user_nicename;
		$this->_email		=	$user->user_email;
		$this->_password	=	''; // what here? WP passwords are encrypted
	}

	public function isSystem() {
		return false;
	}

	public function getId() {
		return $this->_id;
	}

	public function getUsername() {
		return $this->_username;
	}

	public function getEmail() {
		return $this->_email;
	}

	public function getName() {
		return $this->_name;
	}

	public function getPassword() {
		return $this->_password;
	}

	public function __toString()
	{
		return get_class( $this).'['.$this->_id.']['.$this->_email.']['.$this->_name.']';
	}
}